package com.sh.game.script.system;

package ..deTemp.1731943041269;

import com.rpg.log.AbstractLog;
import com.rpg.log.LogService;
import com.sh.communication.msg.AbstractMessage;
import com.sh.game.NetClient.ClientShareThreeConnectCenter;
import com.sh.game.cache.CacheManager;
import com.sh.game.entity.Role;
import com.sh.game.entity.Union;
import com.sh.game.entity.system.EquipRansomData;
import com.sh.game.entity.system.EquipRansomItem;
import com.sh.game.entity.system.SystemDataManager;
import com.sh.game.log.EquipRansomLog;
import com.sh.game.proto.BagProtos;
import com.sh.game.proto.EquipRansomProtos;
import com.sh.game.share.ClientManager;
import com.sh.game.share.message.ResAddRansomEquipMessage;
import com.sh.game.share2.ClientManager2;
import com.sh.game.system.bag.BagItem;
import com.sh.game.system.bag.BagManager;
import com.sh.game.system.chat.ChatManager;
import com.sh.game.system.equipRansom.message.ReqRansomEquipToShareMessage;
import com.sh.game.system.equipRansom.message.ResGetEquipRansomInfoMessage;
import com.sh.game.system.equipRansom.script.IEquipRansomScript;
import com.sh.game.system.mail.MailManager;
import com.sh.game.system.map.GameMap;
import com.sh.game.system.map.MapManager;
import com.sh.game.system.map.obj.IMapObject;
import com.sh.game.system.map.obj.Player;
import com.sh.game.system.player.RoleManager;
import com.sh.game.system.union.UnionManager;
import com.sh.game.util.MessageUtil;
import com.sh.game.util.TimeUtil;
import com.sh.game.world.ApplicationContext;
import com.sh.script.annotation.Script;
import java.util.Collections;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@Script
public class EquipRansomScript implements IEquipRansomScript {
  private static final Logger log = LoggerFactory.getLogger(com.sh.game.script.system.EquipRansomScript.class);
  
  private static final int RANSOM = 1;
  
  private static final int FREE_RANSOM = 2;
  
  public void AddEquipRansomItem(Player pickPlayer, long dropFromId, BagItem bagItem) {
    EquipRansomData ransomData = (EquipRansomData)SystemDataManager.getInstance().getSystemData(EquipRansomData.class);
    if (ransomData == null)
      return; 
    boolean b = ransomData.addRansomItem(bagItem, dropFromId, pickPlayer);
    if (b) {
      Role drop = RoleManager.getInstance().getRoleById(dropFromId);
      if (drop == null)
        return; 
      long now = System.currentTimeMillis();
      MailManager.getInstance().sendMail(pickPlayer.getServerId(), pickPlayer.getId(), 119, 
          Collections.emptyList(), new Object[] { drop.getName(), bagItem.getClickString() });
      long time = 86400000L;
      if (ApplicationContext.getInstance().isShareServer() || 
        ApplicationContext.getInstance().isShareServer2() || 
        ApplicationContext.getInstance().isShareServer3())
        time = TimeUtil.getNextTime(now) - now; 
      MailManager.getInstance().sendMail(drop.getServerId(), drop.getId(), 120, Collections.emptyList(), new Object[] { bagItem
            .getColorString(), TimeUtil.getLeftTimeString2(time) });
      drop.sendUpdateRoleExtraValue();
      pickPlayer.getRole().sendUpdateRoleExtraValue();
      if (ApplicationContext.getInstance().isShareServer() || 
        ApplicationContext.getInstance().isShareServer2() || 
        ApplicationContext.getInstance().isShareServer3()) {
        GameMap map = MapManager.getInstance().getMap((IMapObject)pickPlayer);
        ResAddRansomEquipMessage res = new ResAddRansomEquipMessage();
        EquipRansomProtos.RansomEquipShare.Builder builder = EquipRansomProtos.RansomEquipShare.newBuilder();
        builder.setDropId(drop.getId())
          .setPickUpId(pickPlayer.getId())
          .setPickName(pickPlayer.getName())
          .setDropTime(now)
          .setItem(bagItem.toBagItemInfo())
          .setShareId(ApplicationContext.getInstance().getServerId())
          .setOpenServerMaxTime(TimeUtil.getMaxServerOpenTimeMillis())
          .setDropName(drop.getName())
          .setPickUpServerId(pickPlayer.getServerId())
          .setDropServerId(drop.getServerId())
          .setOverTime(TimeUtil.getNextTime(now));
        Union union = UnionManager.getInstance().getUnionByIdInAllServer(drop.getUnionId());
        if (union != null)
          builder.setUnionName(union.getName()); 
        if (map != null)
          builder.setDropMapName(map.getName()); 
        res.setRansomEquipShare(builder.build());
        MessageUtil.sendMsgToAllGameServer((AbstractMessage)res);
        log.error("给游戏服发送消息");
      } 
    } 
  }
  
  public void FreeReturnItem(Player player, long itemId) {
    EquipRansomData ransomData = (EquipRansomData)SystemDataManager.getInstance().getSystemData(EquipRansomData.class);
    if (ransomData == null)
      return; 
    EquipRansomItem ransomItem = (EquipRansomItem)ransomData.getRansomItemMap().get(Long.valueOf(itemId));
    if (ransomItem == null) {
      MessageUtil.sendTipMessage(468, player.getId());
      return;
    } 
    if (ransomItem.getPickUpId() != player.getId()) {
      MessageUtil.sendTipMessage(469, player.getId());
      return;
    } 
    if (!checkCanRansom(player, ransomItem))
      return; 
    EquipRansomItem item = ransomData.removeRansomItem(itemId, 0, player.getRole());
    if (item == null) {
      MessageUtil.sendTipMessage(470, player.getId());
      return;
    } 
    Role roleById = RoleManager.getInstance().getRoleById(item.getDropRoleId());
    if (roleById == null) {
      log.error("邮件发送错误");
      return;
    } 
    if (ApplicationContext.getInstance().isShareServer()) {
      if (!ClientManager.getInstance().isConnnected(player.getServerId())) {
        MessageUtil.sendTipMessage(471, player.getId());
        return;
      } 
      if (!ClientManager.getInstance().isConnnected(roleById.getServerId())) {
        MessageUtil.sendTipMessage(473, player.getId());
        return;
      } 
    } else if (ApplicationContext.getInstance().isShareServer2()) {
      if (!ClientManager2.getInstance().isConnnected(player.getServerId())) {
        MessageUtil.sendTipMessage(471, player.getId());
        return;
      } 
      if (!ClientManager2.getInstance().isConnnected(roleById.getServerId())) {
        MessageUtil.sendTipMessage(473, player.getId());
        return;
      } 
    } else if (ApplicationContext.getInstance().isShareServer3()) {
      if (!ClientShareThreeConnectCenter.getInstance().isConnected(player.getServerId())) {
        MessageUtil.sendTipMessage(471, player.getId());
        return;
      } 
      if (!ClientShareThreeConnectCenter.getInstance().isConnected(roleById.getServerId())) {
        MessageUtil.sendTipMessage(473, player.getId());
        return;
      } 
    } 
    long unionId = player.getRole().getUnionId();
    Union unionById = UnionManager.getInstance().getUnionById(unionId);
    String unionName = "暂无军团";
    if (unionById != null)
      unionName = unionById.getName(); 
    MailManager.getInstance().sendMail(roleById.getServerId(), item.getDropRoleId(), 118, 
        Collections.singletonList(item.getBagItem()), new Object[] { item.getBagItem().getColorString(), unionName, player.getName() });
    if (item.getShareServerId() != 0)
      sendRansomMsgToGame(itemId, 2); 
    if (roleById.getUnionId() != 0L && roleById.getUnionId() == unionId)
      ChatManager.getInstance().unionChatToMembers(276, roleById, new Object[] { player
            .getRole().getClickName(), roleById.getClickName(), item.getBagItem().getClickString() }); 
    getEquipRansomInfo(player.getId());
    roleById.sendUpdateRoleExtraValue();
    if (item.isDropFromBody() && 
      !BagManager.getInstance().isContinue(item.getBagItem()))
      roleById.UpdateDropInfoByType(item.getDropType(), -1, -1); 
    LogService.submit((AbstractLog)new EquipRansomLog(item.getBagItem().getId(), item.getBagItem().getConfigId(), item
          .getDropRoleId(), item.getPickUpId(), (int)(System.currentTimeMillis() / 1000L), player
          .getServerId(), 3, 0, player.getName(), roleById
          .getName(), player.getServerId(), roleById.getServerId()));
  }
  
  private boolean checkCanRansom(Player player, EquipRansomItem ransomItem) {
    boolean overTime = ransomItem.isOverTime(System.currentTimeMillis());
    if (overTime) {
      MessageUtil.sendTipMessage(474, player.getId());
      return false;
    } 
    if (ransomItem.getShareServerId() != 0 && 
      ApplicationContext.getInstance().isGameServer()) {
      if (ransomItem.getShareServerId() == ApplicationContext.getInstance().getShareServerId()) {
        MessageUtil.sendTopTipMessage("", 416, player.getId());
      } else if (ransomItem.getShareServerId() == ApplicationContext.getInstance().getShareServerId2()) {
        MessageUtil.sendTopTipMessage("", 488, player.getId());
      } else {
        MessageUtil.sendTipMessage(289, player.getId());
      } 
      return false;
    } 
    return true;
  }
  
  private void sendRansomMsgToGame(long itemId, int type) {
    ReqRansomEquipToShareMessage req = new ReqRansomEquipToShareMessage();
    EquipRansomProtos.RansomRequest.Builder builder = EquipRansomProtos.RansomRequest.newBuilder();
    builder.setItemId(itemId).setType(type);
    req.setRansomRequest(builder.build());
    MessageUtil.sendMsgToAllGameServer((AbstractMessage)req);
  }
  
  public void RansomItem(Player player, long itemId) {
    EquipRansomData ransomData = (EquipRansomData)SystemDataManager.getInstance().getSystemData(EquipRansomData.class);
    if (ransomData == null)
      return; 
    EquipRansomItem ransomItem = (EquipRansomItem)ransomData.getRansomItemMap().get(Long.valueOf(itemId));
    if (ransomItem == null) {
      MessageUtil.sendTipMessage(468, player.getId());
      return;
    } 
    if (ransomItem.getDropRoleId() != player.getId()) {
      MessageUtil.sendTipMessage(469, player.getId());
      return;
    } 
    if (!checkCanRansom(player, ransomItem))
      return; 
    Role roleById = RoleManager.getInstance().getRoleById(ransomItem.getPickUpId());
    if (ApplicationContext.getInstance().isShareServer()) {
      if (!ClientManager.getInstance().isConnnected(player.getServerId())) {
        MessageUtil.sendTipMessage(471, player.getId());
        return;
      } 
      if (roleById != null && 
        !ClientManager.getInstance().isConnnected(roleById.getServerId())) {
        MessageUtil.sendTipMessage(473, player.getId());
        return;
      } 
    } else if (ApplicationContext.getInstance().isShareServer2()) {
      if (!ClientManager2.getInstance().isConnnected(player.getServerId())) {
        MessageUtil.sendTipMessage(471, player.getId());
        return;
      } 
      if (roleById != null && 
        !ClientManager2.getInstance().isConnnected(roleById.getServerId())) {
        MessageUtil.sendTipMessage(473, player.getId());
        return;
      } 
    } else if (ApplicationContext.getInstance().isShareServer3()) {
      if (!ClientShareThreeConnectCenter.getInstance().isConnected(player.getServerId())) {
        MessageUtil.sendTipMessage(471, player.getId());
        return;
      } 
      if (roleById != null && 
        !ClientShareThreeConnectCenter.getInstance().isConnected(roleById.getServerId())) {
        MessageUtil.sendTipMessage(473, player.getId());
        return;
      } 
    } 
    BagItem bagItem = ransomItem.getBagItem();
    if (bagItem == null) {
      MessageUtil.sendTipMessage(475, player.getId());
      return;
    } 
    int unionDonate = ransomItem.getMoney();
    log.error("赎回使用军团贡献:{}", Integer.valueOf(unionDonate));
    EquipRansomItem item = ransomData.removeRansomItem(itemId, unionDonate, player.getRole());
    if (item == null) {
      MessageUtil.sendTipMessage(2031, player.getRole());
      return;
    } 
    BagItem removeItem = item.getBagItem();
    int returnTax = RoleManager.getMoYuSundryConfigEffect(586, 0, 2);
    int returnDonate = unionDonate;
    returnDonate = (int)(returnDonate * returnTax / 10.0D);
    log.error("赎回获得军团贡献:{},{}", Integer.valueOf(returnDonate), Double.valueOf(returnTax / 10.0D));
    if (roleById != null) {
      BagItem returnItem = BagManager.getInstance().createBagItem(14, returnDonate, 0L);
      MailManager.getInstance().sendMailDelLog(roleById.getServerId(), roleById.getId(), 116, 
          Collections.singletonList(returnItem), 1, new Object[] { removeItem.getColorString(), player.getName() });
      log.error("发送相应奖励");
    } 
    MailManager.getInstance().sendMailDelLog(player.getServerId(), player.getId(), "系统", "装备扣押", "成功赎回装备", 
        Collections.singletonList(removeItem), 1);
    getEquipRansomInfo(player.getId());
    player.getRole().sendUpdateRoleExtraValue();
    sendRansomMsgToGame(itemId, 1);
    LogService.submit((AbstractLog)new EquipRansomLog(item.getBagItem().getId(), item.getBagItem().getConfigId(), item
          .getDropRoleId(), item.getPickUpId(), (int)(System.currentTimeMillis() / 1000L), player
          .getServerId(), 2, unionDonate, (roleById != null) ? roleById.getName() : "", player
          .getName(), (roleById != null) ? roleById.getServerId() : 0, player.getServerId()));
  }
  
  public void getEquipRansomInfo(long roleId) {
    EquipRansomData ransomData = (EquipRansomData)SystemDataManager.getInstance().getSystemData(EquipRansomData.class);
    if (ransomData != null) {
      ResGetEquipRansomInfoMessage res = new ResGetEquipRansomInfoMessage();
      res.setRansomEquipInfoList(ransomData.getRansomInfo(roleId));
      MessageUtil.sendMsg((AbstractMessage)res, roleId);
    } 
  }
  
  public void sendRansomMailMsg(EquipRansomItem equipRansomItem) {
    BagItem bagItem = equipRansomItem.getBagItem();
    long dropRoleId = equipRansomItem.getDropRoleId();
    long dropTime = equipRansomItem.getDropTime();
    long overTime = equipRansomItem.getOverTime();
    int effect = RoleManager.getMoYuSundryConfigEffect(584, 0, 86400);
    Role roleById = RoleManager.getInstance().getRoleById(dropRoleId);
    if (roleById != null) {
      long time = dropTime + (effect * 1000) - System.currentTimeMillis();
      if (overTime != 0L)
        time = overTime - System.currentTimeMillis(); 
      MailManager.getInstance().sendMail(roleById.getServerId(), roleById.getId(), 120, Collections.emptyList(), new Object[] { bagItem
            .getColorString(), TimeUtil.getLeftTimeString2(time) });
    } 
  }
  
  public void addEquipRansomItemByShare(EquipRansomProtos.RansomEquipShare request) {
    EquipRansomData ransomData = (EquipRansomData)SystemDataManager.getInstance().getSystemData(EquipRansomData.class);
    if (ransomData == null) {
      log.error("不存在");
      return;
    } 
    BagProtos.BagItemInfo item = request.getItem();
    if (item == null) {
      log.error("发送的物品为null,跳出记录");
      return;
    } 
    BagItem bagItem = BagManager.getInstance().createBagItem(item);
    if (bagItem == null) {
      log.error("准备失败");
      return;
    } 
    boolean b = ransomData.addRansomItemShare(bagItem, request);
    if (!b)
      log.error("根据跨服消息增加数据失败"); 
  }
  
  public void EquipRansomToShare(EquipRansomProtos.RansomRequest request) {
    int type = request.getType();
    long itemId = request.getItemId();
    log.error("接收到跨服赎回的消息");
    if (ApplicationContext.getInstance().isGameServer()) {
      EquipRansomData ransomData = (EquipRansomData)SystemDataManager.getInstance().getSystemData(EquipRansomData.class);
      if (ransomData == null)
        return; 
      if (type == 1 || type == 2) {
        EquipRansomItem equipRansomItem = ransomData.removeRansomItem(itemId);
        if (equipRansomItem != null) {
          getEquipRansomInfo(equipRansomItem.getDropRoleId());
          getEquipRansomInfo(equipRansomItem.getPickUpId());
        } 
        CacheManager.getInstance().update(ransomData.getId());
      } else {
        log.error("装备赎回领取失败");
      } 
      log.error("另外一个服");
    } 
  }
  
  public void EquipRansomToGame(EquipRansomProtos.RansomEquipIdList ransomEquipIdList) {
    EquipRansomData ransomData = (EquipRansomData)SystemDataManager.getInstance().getSystemData(EquipRansomData.class);
    if (ransomData == null)
      return; 
    ransomData.checkItemIsTrue(ransomEquipIdList);
  }
}
